---
- name: Made sure DNS lookups succeed
  ansible.windows.win_powershell:
    script: |
      if (nslookup {{ new_domain_domain }} 2>&1 | Select-String -Pattern Non-existent){
        $Ansible.Failed = $true
      }
  register: resolve_domain
  until: resolve_domain is not failed
  retries: 30
  delay: 20
  changed_when: False

- name: Add secondary DCs as domain members
  win_domain_membership:
    dns_domain_name: "{{ new_domain_domain }}"
    domain_admin_user: "{{ new_domain_domainadmin_upn }}"
    domain_admin_password: "{{ new_domain_domainadmin_password }}"
    state: domain
  register: add_member_result
  until: add_member_result is not failed
  retries: 30
  delay: 20
  notify: Reboot if required
  when: not new_domain_pdc

- meta: flush_handlers

- name: Ensure there is a Active Directory domain and forest on secondary DCs
  win_domain_controller:
    dns_domain_name: "{{ new_domain_domain }}"
    domain_admin_user: "{{ new_domain_domainadmin_upn }}"
    domain_admin_password: "{{ new_domain_domainadmin_password }}"
    safe_mode_password: "{{ new_domain_domain_safe_mode_password }}"
    state: domain_controller
  register: promote_dc_result
  until: promote_dc_result is not failed
  retries: 30
  delay: 20
  notify: Reboot no retries
  when: not new_domain_pdc

- meta: flush_handlers

- name: Update Ansible to use changed creds
  set_fact:
    ansible_ssh_user: "{{ new_domain_domainadmin_login }}"
    ansible_ssh_pass: "{{ new_domain_domainadmin_password }}"
    ansible_user: "{{ new_domain_domainadmin_login }}"
    ansible_password: "{{ new_domain_domainadmin_password }}"
  when: not new_domain_pdc

- name: Wait for skipped reboot and valid connection with updated credentials
  wait_for_connection:
    connect_timeout: 2
    delay: 10
    sleep: 2
    timeout: 600
...
